#!/usr/bin/perl

# static char sccsid[] = "@(#)85 1.8 src/ll/config_editor/cgi-bin/login.pl, ll.config, ll_rrur2, rrur21042a 11/10/09 10:56:12\n";

use strict;
use lib "/var/www/ll/cgi-bin";
use LLUtil;
use DBI;
use CGI;
use CGI::Session;
use HTML::Template;

my $query;
read(STDIN,$query,$ENV{'CONTENT_LENGTH'});
$query = unescape($query);

debug_log($query);

$_ = $query;
if(/mysql_user=(.+)&mysql_pass=(.+)/)
{
	my $mysql_host = undef;
	my $mysql_db = undef;

	open(CONF,"/var/www/ll/conf/ll.conf");
	while(<CONF>)
	{
		if(/hostname=(.+)/)
		{
			$mysql_host = $1;
		}
		elsif(/dbname=(.+)/)
		{
			$mysql_db = $1;
		}
	}
	close(CONF);

	my $mysql_user = $1;
	my $mysql_pass = $2;

	my $dbh = DBI->connect("DBI:mysql:database=$mysql_db;host=$mysql_host",$mysql_user,$mysql_pass);
	if(defined($dbh))
	{
		$dbh->disconnect();
		
		my $cgi = CGI->new;
		my $session = new CGI::Session(undef, $cgi, {Directory=>'/tmp'});
		my $sid = $session->id();
		my $cookie = $cgi->cookie(CGISESSID => $sid);
		$session->param("mysql_user", rsa_encrypt($mysql_user));
		$session->param("mysql_pass", rsa_encrypt($mysql_pass));
		$session->param("mysql_host", rsa_encrypt($mysql_host));
		$session->param("mysql_db", rsa_encrypt($mysql_db));
		
		debug_log("write into:".$session->param("mysql_user")."-".$session->param("mysql_pass")."-".$session->param("mysql_host")."-".$session->param("mysql_db"));
                my $rc = 0xffff & system "find /tmp/cgisess_* -mtime +7 | xargs rm -rf";
                if($rc != 0)
                {
                        debug_log("Error when trying to remove the old session files. rc=".$rc);
                }

		print $cgi->redirect(-uri => "/ll/llconfig_editor.pl", -cookie => $cookie);
	}
	else
	{
		use constant TMPL_FILE => LLUtil::TMPL_DIR."/llconfig_login.tmpl";
		my $tmpl = new HTML::Template(filename => TMPL_FILE);
		$tmpl->param("msg" => "Error: invalid user name or password for host ".$mysql_host." and db ".$mysql_db."!");
		print "Content-type: text/html\n\n";
		print $tmpl->output;
	}

}
else
{
	$query = $ENV{QUERY_STRING};
	$query = unescape($query);
	my $cgi = CGI->new;
	if($query =~ /operation=logout/)
	{
		my $sid = $cgi->cookie("CGISESSID") || undef;
		if(defined($sid))
		{
			my $session = new CGI::Session(undef, $sid, {Directory=>'/tmp'});
			$session->clear();
			debug_log("logout!!");
		}
	}
	print $cgi->redirect("/ll/llconfig_editor.pl");
}


